// sver.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int _tmain(int argc, _TCHAR* argv[])
{
	CRYPTO_malloc_init(); 
	ERR_load_crypto_strings(); 
    OpenSSL_add_all_algorithms(); 
    ERR_load_OBJ_strings();	

	BIO *b64 = BIO_new(BIO_f_base64());
	BIO *in=BIO_new_file("in.txt", "rt");
	if(!in) exit(1);
	in = BIO_push(b64, in);

	BIO *out=BIO_new_file("out.txt", "wt");
	if(!out) exit(1);

	PKCS7 *p7 = d2i_PKCS7_bio(in, NULL);
	if(!p7) exit(1);

	X509_STORE *store;
	X509_LOOKUP *lookup;
	if(!(store = X509_STORE_new())) exit(1);
	lookup=X509_STORE_add_lookup(store,X509_LOOKUP_file());
	if (lookup == NULL) exit(1);
	if(!X509_LOOKUP_load_file(lookup,"ca.crt",X509_FILETYPE_PEM)) exit(1);
		
	int v=PKCS7_verify(p7, NULL, store, NULL, out, 0 /*PKCS7_NOCHAIN*/);
	if(v==1)
		printf("Signature verified\n");
	else
		printf("Signature rejected\n");

	BIO_free(in);
	BIO_free(out);
	PKCS7_free(p7);

	BIO *in_all=BIO_new_file("in_all.txt", "rt");
	if(!in_all) exit(1);

	BIO *out2=BIO_new_file("out2.txt", "wt");
	if(!out2) exit(1);

	BIO *out3=NULL;

	PKCS7 *P7 = SMIME_read_PKCS7(in_all,&out3);
	if(!P7) exit(1);

	v=PKCS7_verify(P7, NULL, store, out3, out2, PKCS7_DETACHED /*|PKCS7_TEXT *//*PKCS7_NOCHAIN*/ );
	if(v==1)
		printf("Signature verified\n");
	else
		printf("Signature rejected\n");

	BIO_free(in_all);
	BIO_free(out2);
	BIO_free(out3);
	return 0;
}